const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');

const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Enrollment_learningsDBApi {
  static async create(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const enrollment_learnings = await db.enrollment_learnings.create(
      {
        id: data.id || undefined,

        due_date: data.due_date || null,
        status: data.status || null,
        importHash: data.importHash || null,
        createdById: currentUser.id,
        updatedById: currentUser.id,
      },
      { transaction },
    );

    await enrollment_learnings.setEmployee(data.employee || null, {
      transaction,
    });

    await enrollment_learnings.setCourse(data.course || null, {
      transaction,
    });

    await enrollment_learnings.setAssigned_by(data.assigned_by || null, {
      transaction,
    });

    await enrollment_learnings.setOrganizations(data.organizations || null, {
      transaction,
    });

    return enrollment_learnings;
  }

  static async bulkImport(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    // Prepare data - wrapping individual data transformations in a map() method
    const enrollment_learningsData = data.map((item, index) => ({
      id: item.id || undefined,

      due_date: item.due_date || null,
      status: item.status || null,
      importHash: item.importHash || null,
      createdById: currentUser.id,
      updatedById: currentUser.id,
      createdAt: new Date(Date.now() + index * 1000),
    }));

    // Bulk create items
    const enrollment_learnings = await db.enrollment_learnings.bulkCreate(
      enrollment_learningsData,
      { transaction },
    );

    // For each item created, replace relation files

    return enrollment_learnings;
  }

  static async update(id, data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;
    const globalAccess = currentUser.app_role?.globalAccess;

    const enrollment_learnings = await db.enrollment_learnings.findByPk(
      id,
      {},
      { transaction },
    );

    const updatePayload = {};

    if (data.due_date !== undefined) updatePayload.due_date = data.due_date;

    if (data.status !== undefined) updatePayload.status = data.status;

    updatePayload.updatedById = currentUser.id;

    await enrollment_learnings.update(updatePayload, { transaction });

    if (data.employee !== undefined) {
      await enrollment_learnings.setEmployee(
        data.employee,

        { transaction },
      );
    }

    if (data.course !== undefined) {
      await enrollment_learnings.setCourse(
        data.course,

        { transaction },
      );
    }

    if (data.assigned_by !== undefined) {
      await enrollment_learnings.setAssigned_by(
        data.assigned_by,

        { transaction },
      );
    }

    if (data.organizations !== undefined) {
      await enrollment_learnings.setOrganizations(
        data.organizations,

        { transaction },
      );
    }

    return enrollment_learnings;
  }

  static async deleteByIds(ids, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const enrollment_learnings = await db.enrollment_learnings.findAll({
      where: {
        id: {
          [Op.in]: ids,
        },
      },
      transaction,
    });

    await db.sequelize.transaction(async (transaction) => {
      for (const record of enrollment_learnings) {
        await record.update({ deletedBy: currentUser.id }, { transaction });
      }
      for (const record of enrollment_learnings) {
        await record.destroy({ transaction });
      }
    });

    return enrollment_learnings;
  }

  static async remove(id, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const enrollment_learnings = await db.enrollment_learnings.findByPk(
      id,
      options,
    );

    await enrollment_learnings.update(
      {
        deletedBy: currentUser.id,
      },
      {
        transaction,
      },
    );

    await enrollment_learnings.destroy({
      transaction,
    });

    return enrollment_learnings;
  }

  static async findBy(where, options) {
    const transaction = (options && options.transaction) || undefined;

    const enrollment_learnings = await db.enrollment_learnings.findOne(
      { where },
      { transaction },
    );

    if (!enrollment_learnings) {
      return enrollment_learnings;
    }

    const output = enrollment_learnings.get({ plain: true });

    output.employee = await enrollment_learnings.getEmployee({
      transaction,
    });

    output.course = await enrollment_learnings.getCourse({
      transaction,
    });

    output.assigned_by = await enrollment_learnings.getAssigned_by({
      transaction,
    });

    output.organizations = await enrollment_learnings.getOrganizations({
      transaction,
    });

    return output;
  }

  static async findAll(filter, globalAccess, options) {
    const limit = filter.limit || 0;
    let offset = 0;
    let where = {};
    const currentPage = +filter.page;

    const user = (options && options.currentUser) || null;
    const userOrganizations = (user && user.organizations?.id) || null;

    if (userOrganizations) {
      if (options?.currentUser?.organizationsId) {
        where.organizationsId = options.currentUser.organizationsId;
      }
    }

    offset = currentPage * limit;

    const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [
      {
        model: db.employees,
        as: 'employee',

        where: filter.employee
          ? {
              [Op.or]: [
                {
                  id: {
                    [Op.in]: filter.employee
                      .split('|')
                      .map((term) => Utils.uuid(term)),
                  },
                },
                {
                  user: {
                    [Op.or]: filter.employee
                      .split('|')
                      .map((term) => ({ [Op.iLike]: `%${term}%` })),
                  },
                },
              ],
            }
          : {},
      },

      {
        model: db.learning_courses,
        as: 'course',

        where: filter.course
          ? {
              [Op.or]: [
                {
                  id: {
                    [Op.in]: filter.course
                      .split('|')
                      .map((term) => Utils.uuid(term)),
                  },
                },
                {
                  title: {
                    [Op.or]: filter.course
                      .split('|')
                      .map((term) => ({ [Op.iLike]: `%${term}%` })),
                  },
                },
              ],
            }
          : {},
      },

      {
        model: db.employees,
        as: 'assigned_by',

        where: filter.assigned_by
          ? {
              [Op.or]: [
                {
                  id: {
                    [Op.in]: filter.assigned_by
                      .split('|')
                      .map((term) => Utils.uuid(term)),
                  },
                },
                {
                  user: {
                    [Op.or]: filter.assigned_by
                      .split('|')
                      .map((term) => ({ [Op.iLike]: `%${term}%` })),
                  },
                },
              ],
            }
          : {},
      },

      {
        model: db.organizations,
        as: 'organizations',
      },
    ];

    if (filter) {
      if (filter.id) {
        where = {
          ...where,
          ['id']: Utils.uuid(filter.id),
        };
      }

      if (filter.due_dateRange) {
        const [start, end] = filter.due_dateRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            due_date: {
              ...where.due_date,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            due_date: {
              ...where.due_date,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.active !== undefined) {
        where = {
          ...where,
          active: filter.active === true || filter.active === 'true',
        };
      }

      if (filter.status) {
        where = {
          ...where,
          status: filter.status,
        };
      }

      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map((item) => {
          return Utils.uuid(item);
        });

        where = {
          ...where,
          organizationsId: { [Op.or]: listItems },
        };
      }

      if (filter.createdAtRange) {
        const [start, end] = filter.createdAtRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.lte]: end,
            },
          };
        }
      }
    }

    if (globalAccess) {
      delete where.organizationsId;
    }

    const queryOptions = {
      where,
      include,
      distinct: true,
      order:
        filter.field && filter.sort
          ? [[filter.field, filter.sort]]
          : [['createdAt', 'desc']],
      transaction: options?.transaction,
      logging: console.log,
    };

    if (!options?.countOnly) {
      queryOptions.limit = limit ? Number(limit) : undefined;
      queryOptions.offset = offset ? Number(offset) : undefined;
    }

    try {
      const { rows, count } = await db.enrollment_learnings.findAndCountAll(
        queryOptions,
      );

      return {
        rows: options?.countOnly ? [] : rows,
        count: count,
      };
    } catch (error) {
      console.error('Error executing query:', error);
      throw error;
    }
  }

  static async findAllAutocomplete(
    query,
    limit,
    offset,
    globalAccess,
    organizationId,
  ) {
    let where = {};

    if (!globalAccess && organizationId) {
      where.organizationId = organizationId;
    }

    if (query) {
      where = {
        [Op.or]: [
          { ['id']: Utils.uuid(query) },
          Utils.ilike('enrollment_learnings', 'course', query),
        ],
      };
    }

    const records = await db.enrollment_learnings.findAll({
      attributes: ['id', 'course'],
      where,
      limit: limit ? Number(limit) : undefined,
      offset: offset ? Number(offset) : undefined,
      orderBy: [['course', 'ASC']],
    });

    return records.map((record) => ({
      id: record.id,
      label: record.course,
    }));
  }
};
